import { Component, ComponentType } from "react";
import { Observable, Subscription } from "rxjs";
declare const withObservable: <T>(propName: string, source$: Observable<T>, initialValue?: T) => <P>(BaseComponent: ComponentType<P>) => {
    new (props: P): {
        subscription: Subscription | undefined;
        setObservableValue(val: T): void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        render(): import("react").CElement<P, Component<P, any, any>>;
        context: any;
        setState<K extends "emittedValue">(state: {
            emittedValue?: T;
        } | ((prevState: Readonly<{
            emittedValue?: T;
        }>, props: Readonly<P>) => {
            emittedValue?: T;
        } | Pick<{
            emittedValue?: T;
        }, K>) | Pick<{
            emittedValue?: T;
        }, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<P> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<{
            emittedValue?: T;
        }>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<P>, nextState: Readonly<{
            emittedValue?: T;
        }>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<P>, prevState: Readonly<{
            emittedValue?: T;
        }>): any;
        componentDidUpdate?(prevProps: Readonly<P>, prevState: Readonly<{
            emittedValue?: T;
        }>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<{
            emittedValue?: T;
        }>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<{
            emittedValue?: T;
        }>, nextContext: any): void;
    };
    contextType?: import("react").Context<any>;
};
export default withObservable;
